#!/usr/bin/python
# -*- encoding: utf-8 -*-

__author__ = 'SiG Informática [luis.melo]'

from datetime import datetime

class sigerp_log_terminal:

    COLOR_INFO = '\033[1;94m' # bold blue
    COLOR_ARGS = '\033[1;36m' # bold cyan
    COLOR_RESET = "\033[0;0m" # whites
    BOLD = "\033[1m"

    def info(self, str_modulo, str_function, dict_key_value={}, show_list=False):
        str_function = '%s%s(%s'%(self.BOLD, str_function, self.COLOR_RESET)
        if show_list:
            for key in dict_key_value:
                str_value = str(dict_key_value[key])
                name_args = '%s%s%s'%(self.COLOR_ARGS, str(key), self.COLOR_RESET)
                str_function += '%s=%s, '%(name_args, str_value)
        else:
            for key in dict_key_value:
                value = dict_key_value[key]
                name_args = '%s%s%s'%(self.COLOR_ARGS, str(key), self.COLOR_RESET)
                if isinstance(value, (list, tuple)):
                    str_function += '%s=%d registro(s), '%(name_args, len(value))
                else:
                    str_function += '%s=%s, '%(name_args, str(value))
        str_function += ')'
        str_function =  str_function.replace(', )', '%s)%s'%(self.BOLD, self.COLOR_RESET))
        now = datetime.now().strftime('%Y-%m-%d %H:%M:%S')
        print "%s          %sSIGERP%s %s: %s"%(now, self.COLOR_INFO, self.COLOR_RESET, str_modulo, str_function)